#include <iostream>
#include "conio.h"

using namespace std;

class Stringa
{
     char vett[100];

	 public:

	 // assegnazione di una stringa tramite
	 // l'operatore = (sottoposto a ovverride)  
	 void operator = (char* st)
	 {
		 int i;

		 i = 0;
		 while (st[i] != 0)
		 {
			 vett[i] = st[i];
			 i++;
		 }

		 vett[i] = 0;
	 }

	 // lettura della stringa tramite
	 // l'operatore !
	 char* operator ! ()
	 {
         return(vett);
	 }	 

	 // calcolo della lunghezza della stringa
	 int lunghezza()
	 {
		 int i;

		 i = 0;
		 while (vett[i] != 0)  i++;

		 return(i);
	 }

	 // estrae un carattere in posizione pos dalla stringa
	 char carattere(int pos)
	 {
         if ((pos > 0) && (pos <= (*this).lunghezza()))
			 return(vett[pos - 1]);
		 else
			 return(-1);
	 }

	 // inserisce una stringa nella posizione indicata
	 void inserisci(int pos, Stringa s)
	 {
		  int i, ls;

		  ls = s.lunghezza();

		  // sposta il pezzo finale della stringa in avanti
		  for (i = (*this).lunghezza(); i >= pos; i--)
		  {
			  vett[i + ls] = vett[i];
          }

		  // copia la stringa s nella parte "liberata"
		  for (i = 0; i < ls; i++)
		  {
			 vett[i + pos] = s.carattere(i + 1);
          }
	 }

	 // inserisce una stringa nella posizione indicata
	 void inserisci(int pos, char* s)
	 {
		  int i, ls;
		  Stringa st;

		  st = s;

		  (*this).inserisci(pos, st);
	 }

	 // accodamento alla stringa del contenuto di un altro oggetto stringa 
	 void accoda(Stringa s)
	 {
         (*this).inserisci((*this).lunghezza(), s);
	 }

	 // inserimento in testa del contenuto di un altro oggetto stringa
	 void premette(Stringa s)
	 {
		 (*this).inserisci(0, s);
	 }

	 // accodamento alla stringa di una stringa costante
	 void accoda(char* s)
	 {
		 Stringa st;

		 st = s;
		 (*this).accoda(st);
	 }

	 // inserimento in testa di una stringa costante
	 void premette(char* s)
	 {
		 Stringa st;

		 st = s;
         (*this).premette(st);
	 }
};

void main()
{
	 Stringa s, s2;

	 s = "Ciao";

	 cout << "La lunghezza della stringa assegnata risulta: " << s.lunghezza() << endl;

	 cout << "La stringa assegnata risulta: " << ! s << endl;

	 cout << "Il carattere alla posizione 3 risulta: " << s.carattere(3) << endl;

	 s.inserisci(0," aoaoao ");

	 cout << ! s << endl;

	 s.accoda(" Pippo !!");

	 cout << ! s  << endl;

	 s2 = " (o e' Pluto ?)";

	 s.accoda(s2);

	 cout << ! s  << endl;	 

     getch();
}


